searchNodes=[{"doc":"AltworxBook provides function to interact with Altworx from LiveBook notebooks. There is support for: Normalizer pipeline development and debugging Basic usage Currently notebook needs to be running on the same machine, as Altworx. Connecting to running Altworx is done via AltworxBook.connect_to_altworx/0 . When connection is made, you can call other general purpose functions such as listing topics via AltworxBook.list_topics/0 or only raw topics via AltworxBook.list_raw_topics/0 . Raw messages can be accessed by calling AltworxBook.list_raw_messages/4 . A specific message can be acquired with AltworxBook.get_raw_message/2 . Normalizer pipeline development and debugging Whole pipeline can be executed in a notebook using AltworxBook.run_pipeline/2 on a list of raw messages. Messages can be defined manually or retrieved from an Altworx instance. Pipeline definition is similar to the configuration in config.ini . The only difference is that normalization functions are passed as reference, e.g. Normalizer.Basic.decode -&gt; &amp;Normalizer.Basic.decode/1 ). Normalization results can be displayed as VegaLite graphs in Kino layout by calling AltworxBook.visualize_pipeline_results/1 . You can also debug pipelines by function via AltworxBook.run_pipeline_step/2 which executes a single normalization function. This is useful in combination with printing out intermediate results using IO.inspect/2 or dbg/0 .","ref":"AltworxBook.html","title":"AltworxBook","type":"module"},{"doc":"Connect to running altworx node. Altworx node is expected to be running on the same machine as caller process.","ref":"AltworxBook.html#connect_to_altworx/0","title":"AltworxBook.connect_to_altworx/0","type":"function"},{"doc":"Return message from raw topic by its offset . Examples iex&gt; AltworxBook . get_raw_message ( &quot;reality_network_updates&quot; , 0 ) [ %{ timestamp : 1638430188202 , value : &quot;{&quot; timestamp &quot;: 1638430188202, &quot; type &quot;: &quot; upsert_asset &quot;}&quot; } ]","ref":"AltworxBook.html#get_raw_message/2","title":"AltworxBook.get_raw_message/2","type":"function"},{"doc":"Returns list of messages from kafka raw topic. Args topic_name - name of kafka topic since - timestamp in ms from which will messages be returned count - count of the messages to return options (optional) :json - transform encoded JSON value to elixir term :just_value - return only value without envelope with metadata Examples iex&gt; AltworxBook . list_raw_messages ( &quot;reality_network_updates&quot; , 0 , 1 ) [ % { key : &quot;&quot; , offset : 0 , timestamp : 1638430188202 , value : &quot;{&quot; timestamp &quot;: 1638430188202, &quot; type &quot;: &quot; upsert_asset &quot;}&quot; ] iex&gt; AltworxBook . list_raw_messages ( &quot;reality_network_updates&quot; , 0 , 1 , [ :just_value ] ) [ &quot;{&quot; timestamp &quot;: 1638430188202, &quot; type &quot;: &quot; upsert_asset &quot;}&quot; ] iex&gt; AltworxBook . list_raw_messages ( &quot;reality_network_updates&quot; , 0 , 1 , [ :json ] ) [ % { key : &quot;&quot; , offset : 0 , timestamp : 1638430188202 , value : %{ timestamp : 1638430188202 , type : &quot;usert_asset&quot; } ]","ref":"AltworxBook.html#list_raw_messages/4","title":"AltworxBook.list_raw_messages/4","type":"function"},{"doc":"List all raw topics Altworx has access to. Raw topics contain raw messages received by Altworx Acceptors for Normalizer pipeline to process and transform them into Runtime messages. Examples iex&gt; AltworxBook . list_raw_topics ( ) [ &quot;reality_network_updates&quot; ]","ref":"AltworxBook.html#list_raw_topics/0","title":"AltworxBook.list_raw_topics/0","type":"function"},{"doc":"List all topics altworx has access to. Examples iex&gt; AltworxBook . list_topics ( ) [ &quot;N6_rt_reality_network_updates&quot; , &quot;reality_network_updates&quot; ]","ref":"AltworxBook.html#list_topics/0","title":"AltworxBook.list_topics/0","type":"function"},{"doc":"Execute pipeline definition on list of messages. Args messages - list of raw topic messages steps - list of pipeline steps passed as function reference Examples iex&gt; messages = [ %{ timestamp : 1694680405146 , value : &quot;{&quot; timestamp &quot;: 12345}&quot; } ] ... pipeline = [ &amp; Normalizer.Basic . decode / 1 , &amp; Normalizer.Basic . set_random_type / 1 ] ... AltworxBook . run_pipeline ( messages , pipeline ) [ { :new , % Toolbox.Message { type : &quot;a&quot; , timestamp : 1694680405146 , body : %{ &quot;timestamp&quot; =&gt; 12345 } } } ]","ref":"AltworxBook.html#run_pipeline/2","title":"AltworxBook.run_pipeline/2","type":"function"},{"doc":"Evaluate pipeline step on given message. Args message - raw topic message step - pipeline step passed as function reference Examples iex&gt; message = %{ timestamp : 1694680405146 , value : &quot;{&quot; timestamp &quot;: 12345}&quot; } ... AltworxBook . run_pipeline_step ( message , &amp; Normalizer.Basic . decode / 1 ) % Toolbox.Message { type : nil , timestamp : 1694680405146 , body : %{ &quot;timestamp&quot; =&gt; 12345 } }","ref":"AltworxBook.html#run_pipeline_step/2","title":"AltworxBook.run_pipeline_step/2","type":"function"},{"doc":"Validate pipeline output message produced by evaluating pipeline steps one by one. There is validation baked into runing whole pipeline via AltworxBook.run_pipeline/2 , we need to call this function to check that all required fields have valid values. Args message - pipeline output message Examples iex&gt; message = %{ timestamp : 1694680405146 , value : &quot;{&quot; timestamp &quot;: 12345}&quot; } ... otput_message = AltworxBook . run_pipeline_step ( message , &amp; Normalizer.Basic . decode / 1 ) ... AltworxBook . validate_pipeline_step_output_message ( output_message ) :ok","ref":"AltworxBook.html#validate_pipeline_step_output_message/1","title":"AltworxBook.validate_pipeline_step_output_message/1","type":"function"},{"doc":"Utility function to display results of AltworxBook.run_pipeline/2 . Call this function from your notebook on outputs of AltworxBook.run_pipeline/2 and kino presentation will be displayed. Examples iex&gt; messages = [ %{ timestamp : 1694680405146 , value : &quot;{&quot; timestamp &quot;: 12345}&quot; } ] ... pipeline = [ &amp; Normalizer.Basic . decode / 1 , &amp; Normalizer.Basic . set_random_type / 1 ] ... results = AltworxBook . run_pipeline ( messages , pipeline ) ... AltworxBook . visualize_pipeline_results ( results )","ref":"AltworxBook.html#visualize_pipeline_results/1","title":"AltworxBook.visualize_pipeline_results/1","type":"function"},{"doc":"Module providing interface to Altworx that is running on another node.","ref":"AltworxBook.Altworx.html","title":"AltworxBook.Altworx","type":"module"},{"doc":"Connect to running Altworx node.","ref":"AltworxBook.Altworx.html#connect/0","title":"AltworxBook.Altworx.connect/0","type":"function"},{"doc":"","ref":"AltworxBook.Altworx.html#t:timestamp/0","title":"AltworxBook.Altworx.timestamp/0","type":"type"},{"doc":"Kafka interaction helper functions.","ref":"AltworxBook.Kafka.html","title":"AltworxBook.Kafka","type":"module"},{"doc":"Return list of topics Altworx has access to.","ref":"AltworxBook.Kafka.html#list_topics/0","title":"AltworxBook.Kafka.list_topics/0","type":"function"},{"doc":"Kafka raw topic interaction helper functions.","ref":"AltworxBook.Kafka.RawTopic.html","title":"AltworxBook.Kafka.RawTopic","type":"module"},{"doc":"Return message from topic with given offset.","ref":"AltworxBook.Kafka.RawTopic.html#get_message/2","title":"AltworxBook.Kafka.RawTopic.get_message/2","type":"function"},{"doc":"List all raw topics.","ref":"AltworxBook.Kafka.RawTopic.html#list/0","title":"AltworxBook.Kafka.RawTopic.list/0","type":"function"},{"doc":"Return list of messages from raw topic.","ref":"AltworxBook.Kafka.RawTopic.html#list_messages/4","title":"AltworxBook.Kafka.RawTopic.list_messages/4","type":"function"},{"doc":"","ref":"AltworxBook.Kafka.RawTopic.html#t:message/0","title":"AltworxBook.Kafka.RawTopic.message/0","type":"type"},{"doc":"Normalizer pipeline helper functions.","ref":"AltworxBook.Normalizer.Pipeline.html","title":"AltworxBook.Normalizer.Pipeline","type":"module"},{"doc":"Execute pipeline definition on list of messages.","ref":"AltworxBook.Normalizer.Pipeline.html#run/2","title":"AltworxBook.Normalizer.Pipeline.run/2","type":"function"},{"doc":"Evaluate pipeline step on given message.","ref":"AltworxBook.Normalizer.Pipeline.html#run_step/2","title":"AltworxBook.Normalizer.Pipeline.run_step/2","type":"function"},{"doc":"Validate message result produced by AltworxBook.Normalizer.Pipeline.run_step/2","ref":"AltworxBook.Normalizer.Pipeline.html#validate_output_message/1","title":"AltworxBook.Normalizer.Pipeline.validate_output_message/1","type":"function"},{"doc":"Return kino presentation of pipeline evaluation results.","ref":"AltworxBook.Normalizer.Pipeline.html#visualize_results/1","title":"AltworxBook.Normalizer.Pipeline.visualize_results/1","type":"function"},{"doc":"","ref":"AltworxBook.Normalizer.Pipeline.html#t:pipeline_evaluation_result/0","title":"AltworxBook.Normalizer.Pipeline.pipeline_evaluation_result/0","type":"type"},{"doc":"","ref":"AltworxBook.Normalizer.Pipeline.html#t:pipeline_step/0","title":"AltworxBook.Normalizer.Pipeline.pipeline_step/0","type":"type"},{"doc":"","ref":"AltworxBook.Normalizer.Pipeline.html#t:pipeline_step_result/0","title":"AltworxBook.Normalizer.Pipeline.pipeline_step_result/0","type":"type"},{"doc":"AltworxBook provides function to interact with Altworx from LiveBook notebooks. Currently supported functionality is described in AltworxBook module documentation.","ref":"readme.html","title":"AltworxBook","type":"extras"},{"doc":"To use functionality of this library in your notebook, you need to include it in your dependecies with runbox configuration. Mix . install ( [ { :altworx_book , &quot;~&gt; 0.1.0&quot; } ] , config : [ runbox : [ scenario_config_dir : nil ] ] )","ref":"readme.html#using-in-livebook-notebooks","title":"AltworxBook - Using in LiveBook notebooks","type":"extras"},{"doc":"There are currently these notebooks available: Normalizer pipeline development Normalizer pipeline debugging To run these notebooks start Altworx in developer mode via make in the Altworx repository. This LiveBook should be in the same network. That is, if run from docker, it should be started with the parameter -net host . You can start LiveBook from this repository by calling make .","ref":"readme.html#existing-notebooks","title":"AltworxBook - Existing notebooks","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Changes","ref":"changelog.html#master","title":"Changelog - Master","type":"extras"},{"doc":"Changes Added Altworx interop functions for normalizer pipeline devel/debug livebook notebooks. ( PR , #6096 )","ref":"changelog.html#0-1-0","title":"Changelog - 0.1.0","type":"extras"},{"doc":"Mix . install ( [ { :altworx_book , &quot;~&gt; 0.1.0&quot; } , { :jason , &quot;~&gt; 1.4&quot; } ] , config : [ runbox : [ scenario_config_dir : nil ] , tzdata : [ autoupdate : :disabled ] ] ) AltworxBook . connect_to_altworx ( )","ref":"normalizer_debug.html","title":"Normalizer debug","type":"extras"},{"doc":"Run altworx in developer mode via make in the Altworx repository. This livebook should be in the same network. That is, if run from docker, it should be started with the parameter -net host .","ref":"normalizer_debug.html#altworx-setup","title":"Normalizer debug - Altworx setup","type":"extras"},{"doc":"First we need pipeline module which defines transformation function/s. defmodule Normalizer.Basic do alias Toolbox.Message @doc &quot;&quot;&quot; Attempts to decode the message from JSON. &quot;&quot;&quot; def decode ( % Message { body : body } = msg ) do case Jason . decode ( body ) do { :ok , body } -&gt; %{ msg | body : body } { :error , _ } = error -&gt; error end end @doc &quot;&quot;&quot; Sets the message type from the message body. Falls back to a default value. &quot;&quot;&quot; def set_type ( % Message { body : body } = msg ) do type = body [ &quot;type&quot; ] || &quot;default_type&quot; %{ msg | type : type } end @doc &quot;&quot;&quot; Sets the message timestamp from the message body. As a fallback, keeps the timestamp intact. &quot;&quot;&quot; def set_timestamp ( % Message { body : body } = msg ) do timestamp = body [ &quot;timestamp&quot; ] if is_nil ( timestamp ) do msg else %{ msg | timestamp : timestamp } end end end Then we need pipeline definition. pipeline_simple = [ &amp; Normalizer.Basic . decode / 1 , &amp; Normalizer.Basic . set_type / 1 , &amp; Normalizer.Basic . set_timestamp / 1 ] With this configuration we can start debuging our pipeline functions. We can evaluate whole pipeline. topic_name = &quot;reality_network_updates&quot; since = 0 message_count = 1 msgs = AltworxBook . list_raw_messages ( topic_name , since , message_count ) AltworxBook . run_pipeline ( msgs , pipeline_simple ) Or evaluate each pipeline step one by one and print out its outputs (via IO.inspect/1 or livebook's dbg/0 ). topic_name = &quot;reality_network_updates&quot; message_offset = 0 { :ok , msg } = AltworxBook . get_raw_message ( topic_name , message_offset ) msg |&gt; AltworxBook . run_pipeline_step ( &amp; Normalizer.Basic . decode / 1 ) |&gt; AltworxBook . run_pipeline_step ( &amp; Normalizer.Basic . set_type / 1 ) |&gt; AltworxBook . run_pipeline_step ( &amp; Normalizer.Basic . set_timestamp / 1 ) |&gt; AltworxBook . validate_pipeline_step_output_message ( ) |&gt; dbg ( )","ref":"normalizer_debug.html#pipeline-debug","title":"Normalizer debug - Pipeline debug","type":"extras"},{"doc":"Mix . install ( [ { :altworx_book , &quot;~&gt; 0.1.0&quot; } , { :jason , &quot;~&gt; 1.4&quot; } ] , config : [ runbox : [ scenario_config_dir : nil ] , tzdata : [ autoupdate : :disabled ] ] )","ref":"normalizer_devel.html","title":"Normalizer devel","type":"extras"},{"doc":"First define a module with transformation functions. A transformation function receives a single parameter %Toolbox.Message{} . The function should return one of: %Toolbox.Message{} - an updated message struct. :ignored - the message is silently ignored. {:error, reason} - error has occured during the message processing. defmodule Normalizer.Basic do alias Toolbox.Message @doc &quot;&quot;&quot; Attempts to decode the message from JSON. &quot;&quot;&quot; def decode ( % Message { body : body } = msg ) do case Jason . decode ( body ) do { :ok , body } -&gt; %{ msg | body : body } { :error , _ } = error -&gt; error end end @doc &quot;&quot;&quot; Sets the message type from the message body. Falls back to a default value. &quot;&quot;&quot; def set_type ( % Message { body : body } = msg ) do type = body [ &quot;type&quot; ] || &quot;default_type&quot; %{ msg | type : type } end @doc &quot;&quot;&quot; Sets the message timestamp from the message body. As a fallback, keeps the timestamp intact. &quot;&quot;&quot; def set_timestamp ( % Message { body : body } = msg ) do timestamp = body [ &quot;timestamp&quot; ] if is_nil ( timestamp ) do msg else %{ msg | timestamp : timestamp } end end @doc &quot;&quot;&quot; Handle the messages according to their type. &quot;&quot;&quot; def classify ( % Message { type : type } = msg ) do case type do # ignore all the boring messages &quot;yawn&quot; -&gt; :ignored # error out on bad messages &quot;bad&quot; -&gt; { :error , &quot;bad message&quot; } # keep all other messages _ -&gt; msg end end @doc &quot;&quot;&quot; Set random message type (for demonstartion purposes). &quot;&quot;&quot; def set_random_type ( % Message { } = msg ) do types = [ :type1 , :type2 , :type3 , :type4 ] %{ msg | type : Enum . random ( types ) } end @doc &quot;&quot;&quot; Set random pipeline output (for demonstartion purposes). &quot;&quot;&quot; def set_random_output ( % Message { } = msg ) do case Enum . random ( [ :ok , :error , :raise , :ignored ] ) do :ok -&gt; msg :error -&gt; { :error , &quot;chyba&quot; } :raise -&gt; raise &quot;booom&quot; :ignored -&gt; :ignored end end end","ref":"normalizer_devel.html#transformation-function","title":"Normalizer devel - Transformation function","type":"extras"},{"doc":"Normalizer pipeline consists of one or more transformation functions referenced by &amp;Module.function/1 . The first function receives a struct %Toolbox.Message{} with the :timestamp set to time when the message has arrived into the system and :body set to an unprocessed string. Next function in the pipeline receives the struct %Toolbox.Message{} returned from the previous function, etc. If the last function in the pipeline returns a struct %Toolbox.Message{} it has to have the :type set to an atom or a string value and :timestamp set to an integer value. pipeline = [ &amp; Normalizer.Basic . decode / 1 , &amp; Normalizer.Basic . set_type / 1 , &amp; Normalizer.Basic . set_timestamp / 1 , &amp; Normalizer.Basic . classify / 1 ]","ref":"normalizer_devel.html#pipeline-definition","title":"Normalizer devel - Pipeline definition","type":"extras"},{"doc":"Define a few custom messages and see how the normalizer pipeline handles them. Each message has to be a map with :timestamp and :value keys. Process the messages through the pipeline with the helper AltworxBook.run_pipeline/2 . Result is a list of tuples, each in format {category, msg, original} , where category is one of :new , :error or :ignored , msg is the normalized message and original is the original message. messages = [ %{ timestamp : 1_690_197_171_000 , value : &quot;&quot;&quot; { &quot;timestamp&quot;: 12345, &quot;varA&quot;: &quot;a&quot; } &quot;&quot;&quot; } , %{ timestamp : 1_690_197_172_000 , value : &quot;&quot;&quot; { &quot;type&quot;: &quot;my_type&quot;, &quot;varB&quot;: &quot;b&quot; } &quot;&quot;&quot; } , %{ timestamp : 1_690_197_173_000 , value : &quot;&quot;&quot; { &quot;type&quot;: &quot;yawn&quot; } &quot;&quot;&quot; } , %{ timestamp : 1_690_197_174_000 , value : &quot;&quot;&quot; { &quot;type&quot;: &quot;bad&quot; } &quot;&quot;&quot; } , %{ timestamp : 1_690_197_174_000 , value : &quot;&quot;&quot; not a JSON &quot;&quot;&quot; } ] AltworxBook . run_pipeline ( messages , pipeline )","ref":"normalizer_devel.html#run-the-pipeline-on-custom-messages","title":"Normalizer devel - Run the pipeline on custom messages","type":"extras"},{"doc":"Run altworx in developer mode via make in the Altworx repository. This livebook should be in the same network. That is, if run from docker, it should be started with the parameter -net host .","ref":"normalizer_devel.html#connect-to-an-altworx-node","title":"Normalizer devel - Connect to an Altworx node","type":"extras"},{"doc":"List all topics available on the connected Altworx node. AltworxBook . connect_to_altworx ( ) AltworxBook . list_raw_topics ( )","ref":"normalizer_devel.html#list-topics","title":"Normalizer devel - List topics","type":"extras"},{"doc":"Now run the pipeline on messages from an existing topic. This returns perhaps a long list of terms with messages (depending on the number of the source messages in the topic). pipeline = [ &amp; Normalizer.Basic . decode / 1 , &amp; Normalizer.Basic . set_random_type / 1 , &amp; Normalizer.Basic . set_timestamp / 1 , &amp; Normalizer.Basic . set_random_output / 1 ] topic_name = &quot;reality_network_updates&quot; since = 0 message_count = 100 msgs = AltworxBook . list_raw_messages ( topic_name , since , message_count ) results = AltworxBook . run_pipeline ( msgs , pipeline ) Let's put the resulting messages into tables and graphs. AltworxBook . visualize_pipeline_results ( results )","ref":"normalizer_devel.html#run-pipeline-on-an-existing-topic","title":"Normalizer devel - Run pipeline on an existing topic","type":"extras"},{"doc":"You can debug each pipeline step one by one and inspect its outputs via IO.inspect/2 or livebook's dbg/0 functions. topic_name = &quot;reality_network_updates&quot; message_offset = 0 { :ok , msg } = AltworxBook . get_raw_message ( topic_name , message_offset ) msg |&gt; AltworxBook . run_pipeline_step ( &amp; Normalizer.Basic . decode / 1 ) |&gt; AltworxBook . run_pipeline_step ( &amp; Normalizer.Basic . set_random_type / 1 ) |&gt; AltworxBook . run_pipeline_step ( &amp; Normalizer.Basic . set_timestamp / 1 ) |&gt; AltworxBook . run_pipeline_step ( &amp; Normalizer.Basic . set_random_output / 1 ) |&gt; AltworxBook . validate_pipeline_step_output_message ( ) |&gt; dbg ( )","ref":"normalizer_devel.html#pipeline-debug","title":"Normalizer devel - Pipeline debug","type":"extras"}]